
#include <stdio.h>
#include <stdarg.h>
#include <malloc.h>
#include <windows.h>

static CONSOLE_SCREEN_BUFFER_INFO console_info;
static HANDLE                     stdout_hnd;

static void set_color (unsigned short col)
{
  if (col == 0)
       SetConsoleTextAttribute (stdout_hnd, console_info.wAttributes);
  else SetConsoleTextAttribute (stdout_hnd, (console_info.wAttributes & ~7) | col);
}

/* With gcc:           p: 0022F2B0
 *                     q: 0022F2A0 (diff=16)
 *
 * With MSVC (-MTd):   p: 0012ED90
 *                     q: 0012ED60 (diff=48)
 * With MSVC (-MT):  ...
 *
 */
static void ugly_alloca_diff_test (void)
{
  const char *p = alloca (1);
  const char *q = alloca (1);
  printf ("  p: %p\n"
          "  q: %p (diff=%d)\n", p, q, p-q);
}

static void trace (const char *fmt, ...)
{
  static int init = 0;
  static int debug = 0;

  if (!init)
  {
    const char *env = getenv ("GNUMAKEFLAGS");

    stdout_hnd = GetStdHandle (STD_OUTPUT_HANDLE);
    GetConsoleScreenBufferInfo (stdout_hnd, &console_info);
    if (env && strstr(env,"--debug"))
       debug = 1;
    if (debug)
       ugly_alloca_diff_test();
  }

  init = 1;

  if (debug)
  {
    va_list args;

    va_start (args, fmt);
    set_color (FOREGROUND_INTENSITY | 2); /* bright green */
    fputs (" **: ", stdout);
    vfprintf (stdout, fmt, args);
    fflush (stdout);
    set_color (0);
    va_end (args);
  }
}

